diff --git a/python/altgraph/setup.py b/python/altgraph/setup.py
index a1a4cb6eb2..15913a4417 100644
--- a/python/altgraph/setup.py
+++ b/python/altgraph/setup.py
@@ -15,6 +15,7 @@ Additional functionality:
 
 """
 
+from __future__ import print_function
 import sys
 import os
 import re
@@ -28,7 +29,7 @@ import tarfile
 try:
     import urllib.request as urllib
 except ImportError:
-    import urllib
+    import six.moves.urllib.request, six.moves.urllib.parse, six.moves.urllib.error
 from distutils import log
 try:
     from hashlib import md5
@@ -36,10 +37,7 @@ try:
 except ImportError:
     from md5 import md5
 
-if sys.version_info[0] == 2:
-    from ConfigParser import RawConfigParser, NoOptionError, NoSectionError
-else:
-    from configparser import RawConfigParser, NoOptionError, NoSectionError
+from configparser import RawConfigParser, NoOptionError, NoSectionError
 
 ROOTDIR = os.path.dirname(os.path.abspath(__file__))
 
@@ -226,7 +224,7 @@ def parse_setup_cfg():
     else:
         parts = []
         for nm in v.split():
-            fp = open(nm, 'rU')
+            fp = open(nm)
             parts.append(fp.read())
             fp.close()
 
@@ -295,7 +293,7 @@ try:
 
     def get_pypi_src_download(package):
         url = 'https://pypi.python.org/pypi/%s/json'%(package,)
-        fp = urllib.urlopen(url)
+        fp = six.moves.urllib.request.urlopen(url)
         try:
             try:
                 data = fp.read()
@@ -323,7 +321,7 @@ except ImportError:
 
     def get_pypi_src_download(package):
         url = 'https://pypi.python.org/pypi/%s/json'%(package,)
-        fp = urllib.urlopen(url)
+        fp = six.moves.urllib.request.urlopen(url)
         try:
             try:
                 data = fp.read()
@@ -412,7 +410,7 @@ def _build_egg(egg, tarball, to_dir):
     # returning the result
     log.warn(egg)
     if not os.path.exists(egg):
-        raise IOError('Could not build the egg.')
+        raise OSError('Could not build the egg.')
 
 
 def _do_download(to_dir, packagename=SETUPTOOLS_PACKAGE):
@@ -437,7 +435,7 @@ def download_setuptools(packagename, to_dir):
     try:
         from urllib.request import urlopen
     except ImportError:
-        from urllib2 import urlopen
+        from urllib.request import urlopen
 
     chksum, url = get_pypi_src_download(packagename)
     tgz_name = os.path.basename(url)
@@ -579,11 +577,11 @@ else:
             import shutil
             import zipfile
             import os
-            import urllib
+            import six.moves.urllib.request, six.moves.urllib.parse, six.moves.urllib.error
             import StringIO
             from base64 import standard_b64encode
-            import httplib
-            import urlparse
+            import six.moves.http_client
+            import six.moves.urllib.parse
 
             # Extract the package name from distutils metadata
             meta = self.distribution.metadata
@@ -611,7 +609,7 @@ else:
                     fullname = os.path.join(toplevel, fn)
                     relname = os.path.relpath(fullname, 'doc/_build/html')
 
-                    print ("%s -> %s"%(fullname, relname))
+                    print(("%s -> %s"%(fullname, relname)))
 
                     zf.write(fullname, relname)
 
@@ -658,13 +656,13 @@ else:
             self.announce("Uploading documentation to %s"%(self.repository,), log.INFO)
 
             schema, netloc, url, params, query, fragments = \
-                    urlparse.urlparse(self.repository)
+                    six.moves.urllib.parse.urlparse(self.repository)
 
 
             if schema == 'http':
-                http = httplib.HTTPConnection(netloc)
+                http = six.moves.http_client.HTTPConnection(netloc)
             elif schema == 'https':
-                http = httplib.HTTPSConnection(netloc)
+                http = six.moves.http_client.HTTPSConnection(netloc)
             else:
                 raise AssertionError("unsupported schema "+schema)
 
@@ -679,22 +677,22 @@ else:
                 http.putheader('Authorization', auth)
                 http.endheaders()
                 http.send(body)
-            except socket.error:
+            except OSError:
                 e = socket.exc_info()[1]
                 self.announce(str(e), log.ERROR)
                 return
 
             r = http.getresponse()
             if r.status in (200, 301):
-                self.announce('Upload succeeded (%s): %s' % (r.status, r.reason),
+                self.announce('Upload succeeded ({}): {}'.format(r.status, r.reason),
                     log.INFO)
             else:
-                self.announce('Upload failed (%s): %s' % (r.status, r.reason),
+                self.announce('Upload failed ({}): {}'.format(r.status, r.reason),
                     log.ERROR)
 
-                print ('-'*75)
-                print (r.read())
-                print ('-'*75)
+                print(('-'*75))
+                print((r.read()))
+                print(('-'*75))
 
 
 def recursiveGlob(root, pathPattern):
@@ -718,7 +716,7 @@ def importExternalTestCases(unittest,
     """
 
     testFiles = recursiveGlob(root, pathPattern)
-    testModules = map(lambda x:x[len(root)+1:-3].replace('/', '.'), testFiles)
+    testModules = [x[len(root)+1:-3].replace('/', '.') for x in testFiles]
     if package is not None:
         testModules = [(package + '.' + m) for m in testModules]
 
@@ -728,7 +726,7 @@ def importExternalTestCases(unittest,
         try:
             module = __import__(modName)
         except ImportError:
-            print("SKIP %s: %s"%(modName, sys.exc_info()[1]))
+            print(("SKIP %s: %s"%(modName, sys.exc_info()[1])))
             continue
 
         if '.' in modName:
@@ -843,7 +841,7 @@ class test (Command):
                 xpass=len(getattr(result, 'expectedSuccesses', [])),
                 skip=len(getattr(result, 'skipped', [])),
             )
-            print("SUMMARY: %s"%(summary,))
+            print(("SUMMARY: %s"%(summary,)))
 
         finally:
             self.remove_from_sys_path()
diff --git a/python/bitstring/bitstring.py b/python/bitstring/bitstring.py
index 86f969c7f2..b7af104ee5 100644
--- a/python/bitstring/bitstring.py
+++ b/python/bitstring/bitstring.py
@@ -13,12 +13,12 @@ BitStream -- A mutable container with streaming methods.
 
                       Bits (base class)
                      /    \
- + mutating methods /      \ + streaming methods
+ + mutating methods /      \\ + streaming methods
                    /        \
               BitArray   ConstBitStream
-                   \        /
-                    \      /
-                     \    /
+                   \\        /
+                    \\      /
+                     \\    /
                     BitStream
 
 Functions:
@@ -127,7 +127,7 @@ class CreationError(Error, ValueError):
         Error.__init__(self, *params)
 
 
-class ConstByteStore(object):
+class ConstByteStore:
     """Stores raw bytes together with a bit offset and length.
 
     Used internally - not part of public interface.
@@ -391,7 +391,7 @@ def equal(a, b):
     return a_val == b_val
 
 
-class MmapByteArray(object):
+class MmapByteArray:
     """Looks like a bytearray, but from an mmap.
 
     Not part of public interface.
@@ -446,13 +446,13 @@ BYTE_REVERSAL_DICT = dict()
 try:
     xrange
     for i in range(256):
-        BYTE_REVERSAL_DICT[i] = chr(int("{0:08b}".format(i)[::-1], 2))
+        BYTE_REVERSAL_DICT[i] = chr(int("{:08b}".format(i)[::-1], 2))
 except NameError:
     for i in range(256):
-        BYTE_REVERSAL_DICT[i] = bytes([int("{0:08b}".format(i)[::-1], 2)])
+        BYTE_REVERSAL_DICT[i] = bytes([int("{:08b}".format(i)[::-1], 2)])
     from io import IOBase as file
     xrange = range
-    basestring = str
+    str = str
 
 # Python 2.x octals start with '0', in Python 3 it's '0o'
 LEADING_OCT_CHARS = len(oct(1)) - 1
@@ -588,7 +588,7 @@ def tokenparser(fmt, keys=None, token_cache={}):
                 # and if you don't specify a 'name' then the default is 'uint':
                 m2 = DEFAULT_UINT.match(token)
                 if not m2:
-                    raise ValueError("Don't understand token '{0}'.".format(token))
+                    raise ValueError("Don't understand token '{}'.".format(token))
             if m1:
                 name = m1.group('name')
                 length = m1.group('len')
@@ -619,7 +619,7 @@ def tokenparser(fmt, keys=None, token_cache={}):
                     raise ValueError("Can't read a token with a negative length.")
                 except ValueError:
                     if not keys or length not in keys:
-                        raise ValueError("Don't understand length '{0}' of token.".format(length))
+                        raise ValueError("Don't understand length '{}' of token.".format(length))
             ret_vals.append([name, length, value])
         # This multiplies by the multiplicative factor, but this means that
         # we can't allow keyword values as multipliers (e.g. n*uint:8).
@@ -653,7 +653,7 @@ def expand_brackets(s):
                 break
             p += 1
         if count:
-            raise ValueError("Unbalanced parenthesis in '{0}'.".format(s))
+            raise ValueError("Unbalanced parenthesis in '{}'.".format(s))
         if start == 0 or s[start - 1] != '*':
             s = s[0:start] + s[start + 1:p] + s[p + 1:]
         else:
@@ -663,18 +663,18 @@ def expand_brackets(s):
                 matchstart = m.start('factor')
                 s = s[0:matchstart] + (factor - 1) * (s[start + 1:p] + ',') + s[start + 1:p] + s[p + 1:]
             else:
-                raise ValueError("Failed to parse '{0}'.".format(s))
+                raise ValueError("Failed to parse '{}'.".format(s))
     return s
 
 
 # This converts a single octal digit to 3 bits.
-OCT_TO_BITS = ['{0:03b}'.format(i) for i in xrange(8)]
+OCT_TO_BITS = ['{:03b}'.format(i) for i in range(8)]
 
 # A dictionary of number of 1 bits contained in binary representation of any byte
-BIT_COUNT = dict(zip(xrange(256), [bin(i).count('1') for i in xrange(256)]))
+BIT_COUNT = dict(zip(range(256), [bin(i).count('1') for i in range(256)]))
 
 
-class Bits(object):
+class Bits:
     """A container holding an immutable sequence of bits.
 
     For a mutable container use the BitArray class instead.
@@ -772,7 +772,7 @@ class Bits(object):
         # For instances auto-initialised with a string we intern the
         # instance for re-use.
         try:
-            if isinstance(auto, basestring):
+            if isinstance(auto, str):
                 try:
                     return _cache[auto]
                 except KeyError:
@@ -792,7 +792,7 @@ class Bits(object):
                 return auto
         except TypeError:
             pass
-        x = super(Bits, cls).__new__(cls)
+        x = super().__new__(cls)
         x._initialise(auto, length, offset, **kwargs)
         return x
 
@@ -843,16 +843,16 @@ class Bits(object):
         return self
 
     def __lt__(self, other):
-        raise TypeError("unorderable type: {0}".format(type(self).__name__))
+        raise TypeError("unorderable type: {}".format(type(self).__name__))
 
     def __gt__(self, other):
-        raise TypeError("unorderable type: {0}".format(type(self).__name__))
+        raise TypeError("unorderable type: {}".format(type(self).__name__))
 
     def __le__(self, other):
-        raise TypeError("unorderable type: {0}".format(type(self).__name__))
+        raise TypeError("unorderable type: {}".format(type(self).__name__))
 
     def __ge__(self, other):
-        raise TypeError("unorderable type: {0}".format(type(self).__name__))
+        raise TypeError("unorderable type: {}".format(type(self).__name__))
 
     def __add__(self, bs):
         """Concatenate bitstrings and return new bitstring.
@@ -967,14 +967,14 @@ class Bits(object):
             if self._datastore.byteoffset or self._offset:
                 offsetstring = ", offset=%d" % (self._datastore._rawarray.byteoffset * 8 + self._offset)
             lengthstring = ", length=%d" % length
-            return "{0}(filename='{1}'{2}{3})".format(self.__class__.__name__,
+            return "{}(filename='{}'{}{})".format(self.__class__.__name__,
                     self._datastore._rawarray.source.name, lengthstring, offsetstring)
         else:
             s = self.__str__()
             lengthstring = ''
             if s.endswith('...'):
-                lengthstring = " # length={0}".format(length)
-            return "{0}('{1}'){2}".format(self.__class__.__name__, s, lengthstring)
+                lengthstring = " # length={}".format(length)
+            return "{}('{}'){}".format(self.__class__.__name__, s, lengthstring)
 
     def __eq__(self, bs):
         """Return True if two bitstrings have the same binary representation.
@@ -1195,7 +1195,7 @@ class Bits(object):
     def _assertsanity(self):
         """Check internal self consistency as a debugging aid."""
         assert self.len >= 0
-        assert 0 <= self._offset, "offset={0}".format(self._offset)
+        assert 0 <= self._offset, "offset={}".format(self._offset)
         assert (self.len + self._offset + 7) // 8 == self._datastore.bytelength + self._datastore.byteoffset
         return True
 
@@ -1211,9 +1211,9 @@ class Bits(object):
 
         if value is None:
             if token_length is None:
-                error = "Token has no value ({0}=???).".format(name)
+                error = "Token has no value ({}=???).".format(name)
             else:
-                error = "Token has no value ({0}:{1}=???).".format(name, token_length)
+                error = "Token has no value ({}:{}=???).".format(name, token_length)
             raise ValueError(error)
         try:
             b = cls(**{_tokenname_to_initialiser[name]: value})
@@ -1270,7 +1270,7 @@ class Bits(object):
             raise CreationError("The length keyword isn't applicable to this initialiser.")
         if offset:
             raise CreationError("The offset keyword isn't applicable to this initialiser.")
-        if isinstance(s, basestring):
+        if isinstance(s, str):
             bs = self._converttobitstring(s)
             assert bs._offset == 0
             self._setbytes_unsafe(bs._datastore.rawbytes, bs.length, 0)
@@ -1286,11 +1286,11 @@ class Bits(object):
             data = bytearray((s + 7) // 8)
             self._datastore = ByteStore(data, s, 0)
             return
-        if isinstance(s, collections.Iterable):
+        if isinstance(s, collections.abc.Iterable):
             # Evaluate each item as True or False and set bits to 1 or 0.
             self._setbin_unsafe(''.join(str(int(bool(x))) for x in s))
             return
-        raise TypeError("Cannot initialise bitstring from {0}.".format(type(s)))
+        raise TypeError("Cannot initialise bitstring from {}.".format(type(s)))
 
     def _setfile(self, filename, length, offset):
         """Use file as source of bits."""
@@ -1499,7 +1499,7 @@ class Bits(object):
                 val <<= 8 * chunksize
                 val += struct.unpack('<L', bytes(self._datastore.getbyteslice(endbyte + 1 - chunksize, endbyte + 1)))[0]
                 endbyte -= chunksize
-            for b in xrange(endbyte, startbyte - 1, -1):
+            for b in range(endbyte, startbyte - 1, -1):
                 val <<= 8
                 val += self._datastore.getbyte(b)
         else:
@@ -1832,7 +1832,7 @@ class Bits(object):
                            if len(binstring) < boundary else binstring
         try:
             bytelist = [int(padded_binstring[x:x + 8], 2)
-                        for x in xrange(0, len(padded_binstring), 8)]
+                        for x in range(0, len(padded_binstring), 8)]
         except ValueError:
             raise CreationError("Invalid character in bin initialiser {0}.", binstring)
         self._setbytes_unsafe(bytearray(bytelist), length, 0)
@@ -1905,7 +1905,7 @@ class Bits(object):
                 data = bytearray.fromhex(hexstring)
             except TypeError:
                 # Python 2.6 needs a unicode string (a bug). 2.7 and 3.x work fine.
-                data = bytearray.fromhex(unicode(hexstring))
+                data = bytearray.fromhex(str(hexstring))
         except ValueError:
             raise CreationError("Invalid symbol in hex initialiser.")
         self._setbytes_unsafe(data, length * 4, 0)
@@ -1956,7 +1956,7 @@ class Bits(object):
         try:
             return cache[(bs, offset)]
         except KeyError:
-            if isinstance(bs, basestring):
+            if isinstance(bs, str):
                 b = cls()
                 try:
                     _, tokens = tokenparser(bs)
@@ -1999,14 +1999,14 @@ class Bits(object):
         """Reads a token from the bitstring and returns the result."""
         if length is not None and int(length) > self.length - pos:
             raise ReadError("Reading off the end of the data. "
-                            "Tried to read {0} bits when only {1} available.".format(int(length), self.length - pos))
+                            "Tried to read {} bits when only {} available.".format(int(length), self.length - pos))
         try:
             val = name_to_read[name](self, length, pos)
             return val, pos + length
         except KeyError:
             if name == 'pad':
                 return None, pos + length
-            raise ValueError("Can't parse token {0}:{1}".format(name, length))
+            raise ValueError("Can't parse token {}:{}".format(name, length))
         except TypeError:
             # This is for the 'ue', 'se' and 'bool' tokens. They will also return the new pos.
             return name_to_read[name](self, pos)
@@ -2169,7 +2169,7 @@ class Bits(object):
         """Invert every bit."""
         set = self._datastore.setbyte
         get = self._datastore.getbyte
-        for p in xrange(self._datastore.byteoffset, self._datastore.byteoffset + self._datastore.bytelength):
+        for p in range(self._datastore.byteoffset, self._datastore.byteoffset + self._datastore.bytelength):
             set(p, 256 + ~get(p))
 
     def _ilshift(self, n):
@@ -2212,7 +2212,7 @@ class Bits(object):
                 self._datastore = offsetcopy(self._datastore, bs_bitoffset)
         a = self._datastore.rawbytes
         b = bs._datastore.rawbytes
-        for i in xrange(len(a)):
+        for i in range(len(a)):
             a[i] = f(a[i + self_byteoffset], b[i + bs_byteoffset])
         return self
 
@@ -2267,13 +2267,13 @@ class Bits(object):
     def _readlist(self, fmt, pos, **kwargs):
         tokens = []
         stretchy_token = None
-        if isinstance(fmt, basestring):
+        if isinstance(fmt, str):
             fmt = [fmt]
         # Not very optimal this, but replace integers with 'bits' tokens
         # TODO: optimise
         for i, f in enumerate(fmt):
             if isinstance(f, numbers.Integral):
-                fmt[i] = "bits:{0}".format(f)
+                fmt[i] = "bits:{}".format(f)
         for f_item in fmt:
             stretchy, tkns = tokenparser(f_item, tuple(sorted(kwargs.keys())))
             if stretchy:
@@ -2720,12 +2720,12 @@ class Bits(object):
         value = bool(value)
         length = self.len
         if pos is None:
-            pos = xrange(self.len)
+            pos = range(self.len)
         for p in pos:
             if p < 0:
                 p += length
             if not 0 <= p < length:
-                raise IndexError("Bit position {0} out of range.".format(p))
+                raise IndexError("Bit position {} out of range.".format(p))
             if not self._datastore.getbit(p) is value:
                 return False
         return True
@@ -2742,12 +2742,12 @@ class Bits(object):
         value = bool(value)
         length = self.len
         if pos is None:
-            pos = xrange(self.len)
+            pos = range(self.len)
         for p in pos:
             if p < 0:
                 p += length
             if not 0 <= p < length:
-                raise IndexError("Bit position {0} out of range.".format(p))
+                raise IndexError("Bit position {} out of range.".format(p))
             if self._datastore.getbit(p) is value:
                 return True
         return False
@@ -2766,7 +2766,7 @@ class Bits(object):
             return 0
         # count the number of 1s (from which it's easy to work out the 0s).
         # Don't count the final byte yet.
-        count = sum(BIT_COUNT[self._datastore.getbyte(i)] for i in xrange(self._datastore.bytelength - 1))
+        count = sum(BIT_COUNT[self._datastore.getbyte(i)] for i in range(self._datastore.bytelength - 1))
         # adjust for bits at start that aren't part of the bitstring
         if self._offset:
             count -= BIT_COUNT[self._datastore.getbyte(0) >> (8 - self._offset)]
@@ -3043,7 +3043,7 @@ class BitArray(Bits):
             self._ensureinmemory()
 
     def __new__(cls, auto=None, length=None, offset=None, **kwargs):
-        x = super(BitArray, cls).__new__(cls)
+        x = super().__new__(cls)
         y = Bits.__new__(BitArray, auto, length, offset, **kwargs)
         x._datastore = y._datastore
         return x
@@ -3104,7 +3104,7 @@ class BitArray(Bits):
                 if value in (1, -1):
                     self._set(key)
                     return
-                raise ValueError("Cannot set a single bit with integer {0}.".format(value))
+                raise ValueError("Cannot set a single bit with integer {}.".format(value))
             value = Bits(value)
             if value.len == 1:
                 # TODO: this can't be optimal
@@ -3134,7 +3134,7 @@ class BitArray(Bits):
                     value = Bits(value)
                 except TypeError:
                     raise TypeError("Bitstring, integer or string expected. "
-                                    "Got {0}.".format(type(value)))
+                                    "Got {}.".format(type(value)))
             if key.start is not None:
                 start = key.start
                 if key.start < 0:
@@ -3458,21 +3458,21 @@ class BitArray(Bits):
         """
         f = self._set if value else self._unset
         if pos is None:
-            pos = xrange(self.len)
+            pos = range(self.len)
         try:
             length = self.len
             for p in pos:
                 if p < 0:
                     p += length
                 if not 0 <= p < length:
-                    raise IndexError("Bit position {0} out of range.".format(p))
+                    raise IndexError("Bit position {} out of range.".format(p))
                 f(p)
         except TypeError:
             # Single pos
             if pos < 0:
                 pos += self.len
             if not 0 <= pos < length:
-                raise IndexError("Bit position {0} out of range.".format(pos))
+                raise IndexError("Bit position {} out of range.".format(pos))
             f(pos)
 
     def invert(self, pos=None):
@@ -3487,7 +3487,7 @@ class BitArray(Bits):
         if pos is None:
             self._invert_all()
             return
-        if not isinstance(pos, collections.Iterable):
+        if not isinstance(pos, collections.abc.Iterable):
             pos = (pos,)
         length = self.len
 
@@ -3495,7 +3495,7 @@ class BitArray(Bits):
             if p < 0:
                 p += length
             if not 0 <= p < length:
-                raise IndexError("Bit position {0} out of range.".format(p))
+                raise IndexError("Bit position {} out of range.".format(p))
             self._invert(p)
 
     def ror(self, bits, start=None, end=None):
@@ -3560,12 +3560,12 @@ class BitArray(Bits):
             bytesizes = [(end - start) // 8]
         elif isinstance(fmt, numbers.Integral):
             if fmt < 0:
-                raise ValueError("Improper byte length {0}.".format(fmt))
+                raise ValueError("Improper byte length {}.".format(fmt))
             bytesizes = [fmt]
-        elif isinstance(fmt, basestring):
+        elif isinstance(fmt, str):
             m = STRUCT_PACK_RE.match(fmt)
             if not m:
-                raise ValueError("Cannot parse format string {0}.".format(fmt))
+                raise ValueError("Cannot parse format string {}.".format(fmt))
             # Split the format string into a list of 'q', '4h' etc.
             formatlist = re.findall(STRUCT_SPLIT_RE, m.group('fmt'))
             # Now deal with multiplicative factors, 4h -> hhhh etc.
@@ -3575,11 +3575,11 @@ class BitArray(Bits):
                     bytesizes.append(PACK_CODE_SIZE[f])
                 else:
                     bytesizes.extend([PACK_CODE_SIZE[f[-1]]] * int(f[:-1]))
-        elif isinstance(fmt, collections.Iterable):
+        elif isinstance(fmt, collections.abc.Iterable):
             bytesizes = fmt
             for bytesize in bytesizes:
                 if not isinstance(bytesize, numbers.Integral) or bytesize < 0:
-                    raise ValueError("Improper byte length {0}.".format(bytesize))
+                    raise ValueError("Improper byte length {}.".format(bytesize))
         else:
             raise TypeError("Format must be an integer, string or iterable.")
 
@@ -3593,7 +3593,7 @@ class BitArray(Bits):
         else:
             # Just try one (set of) byteswap(s).
             finalbit = start + totalbitsize
-        for patternend in xrange(start + totalbitsize, finalbit + 1, totalbitsize):
+        for patternend in range(start + totalbitsize, finalbit + 1, totalbitsize):
             bytestart = patternend - totalbitsize
             for bytesize in bytesizes:
                 byteend = bytestart + bytesize * 8
@@ -3781,7 +3781,7 @@ class ConstBitStream(Bits):
         self._pos = 0
 
     def __new__(cls, auto=None, length=None, offset=None, **kwargs):
-        x = super(ConstBitStream, cls).__new__(cls)
+        x = super().__new__(cls)
         x._initialise(auto, length, offset, **kwargs)
         return x
 
@@ -3880,7 +3880,7 @@ class ConstBitStream(Bits):
         _, token = tokenparser(fmt)
         if len(token) != 1:
             self._pos = p
-            raise ValueError("Format string should be a single token, not {0} "
+            raise ValueError("Format string should be a single token, not {} "
                              "tokens - use readlist() instead.".format(len(token)))
         name, length, _ = token[0]
         if length is None:
@@ -4121,7 +4121,7 @@ class BitStream(ConstBitStream, BitArray):
             self._ensureinmemory()
 
     def __new__(cls, auto=None, length=None, offset=None, **kwargs):
-        x = super(BitStream, cls).__new__(cls)
+        x = super().__new__(cls)
         x._initialise(auto, length, offset, **kwargs)
         return x
 
@@ -4186,7 +4186,7 @@ def pack(fmt, *values, **kwargs):
 
     """
     tokens = []
-    if isinstance(fmt, basestring):
+    if isinstance(fmt, str):
         fmt = [fmt]
     try:
         for f_item in fmt:
diff --git a/python/bitstring/test/test_bitarray.py b/python/bitstring/test/test_bitarray.py
index b80f90617b..9436f84620 100644
--- a/python/bitstring/test/test_bitarray.py
+++ b/python/bitstring/test/test_bitarray.py
@@ -255,7 +255,7 @@ class SliceAssignment(unittest.TestCase):
             self.assertTrue(False)
         except ValueError:
             pass
-        class A(object): pass
+        class A: pass
         try:
             a[1:2] = A()
             self.assertTrue(False)
diff --git a/python/bitstring/test/test_bitstream.py b/python/bitstring/test/test_bitstream.py
index f94193d324..4ddd5b1779 100644
--- a/python/bitstring/test/test_bitstream.py
+++ b/python/bitstring/test/test_bitstream.py
@@ -757,7 +757,7 @@ class FromFile(unittest.TestCase):
         # and so this test won't work for anyone except me!
         try:
             s = ConstBitStream(filename='11GB.mkv')
-        except IOError:
+        except OSError:
             return
         self.assertEqual(s.len, 11743020505 * 8)
         self.assertEqual(s[1000000000:1000000100].hex, 'bdef7335d4545f680d669ce24')
@@ -1529,7 +1529,7 @@ class Adding(unittest.TestCase):
         s5 = BitStream(bytes=b'\xff', offset=2, length=3)
         s6 = BitStream('0b111')
         self.assertTrue(s5 == s6)
-        class A(object):
+        class A:
             pass
         self.assertFalse(s5 == A())
 
@@ -2493,7 +2493,7 @@ class Split(unittest.TestCase):
         s = pack('<2h', 1, 2)
         a, b = s.unpack('<2h')
         self.assertEqual((a, b), (1, 2))
-        s = pack('<100q', *range(100))
+        s = pack('<100q', *list(range(100)))
         self.assertEqual(s.len, 100 * 64)
         self.assertEqual(s[44*64:45*64].uintle, 44)
         s = pack('@L0B2h', 5, 5, 5)
@@ -2812,7 +2812,7 @@ class Split(unittest.TestCase):
         b = ConstBitStream('0x2')
         c = ConstBitStream('0x1')
         c.pos = 3
-        s = set((a, b, c))
+        s = {a, b, c}
         self.assertEqual(len(s), 2)
         self.assertEqual(hash(a), hash(c))
 
@@ -2875,9 +2875,9 @@ class Set(unittest.TestCase):
 
     def testSetList(self):
         a = BitStream(length=18)
-        a.set(True, range(18))
+        a.set(True, list(range(18)))
         self.assertEqual(a.int, -1)
-        a.set(False, range(18))
+        a.set(False, list(range(18)))
         self.assertEqual(a.int, 0)
 
     def testUnset(self):
@@ -2907,7 +2907,7 @@ class Set(unittest.TestCase):
 class Invert(unittest.TestCase):
     def testInvertBits(self):
         a = BitStream('0b111000')
-        a.invert(range(a.len))
+        a.invert(list(range(a.len)))
         self.assertEqual(a, '0b000111')
         a.invert([0, 1, -1])
         self.assertEqual(a, '0b110110')
@@ -3456,8 +3456,8 @@ class Bugs(unittest.TestCase):
         self.assertEqual(s.len, 17)
 
     def testInitFromIterable(self):
-        self.assertTrue(isinstance(range(10), collections.Iterable))
-        s = ConstBitStream(range(12))
+        self.assertTrue(isinstance(list(range(10)), collections.abc.Iterable))
+        s = ConstBitStream(list(range(12)))
         self.assertEqual(s, '0x7ff')
 
     def testFunctionNegativeIndices(self):
@@ -3554,7 +3554,7 @@ class Bugs(unittest.TestCase):
         self.assertRaises(ValueError, a.rol, 5, start=-4, end=-6)
 
     def testByteSwapInt(self):
-        s = pack('5*uintle:16', *range(10, 15))
+        s = pack('5*uintle:16', *list(range(10, 15)))
         self.assertEqual(list(range(10, 15)), s.unpack('5*uintle:16'))
         swaps = s.byteswap(2)
         self.assertEqual(list(range(10, 15)), s.unpack('5*uintbe:16'))
@@ -3588,7 +3588,7 @@ class Bugs(unittest.TestCase):
 
     def testByteSwapIterable(self):
         s = BitStream('0x0011223344556677')
-        swaps = s.byteswap(range(1, 4), repeat=False)
+        swaps = s.byteswap(list(range(1, 4)), repeat=False)
         self.assertEqual(swaps, 1)
         self.assertEqual(s, '0x0022115544336677')
         swaps = s.byteswap([2], start=8)
@@ -3628,7 +3628,7 @@ class Bugs(unittest.TestCase):
     def testBracketTokens(self):
         s = BitStream('3*(0x0, 0b1)')
         self.assertEqual(s, '0x0, 0b1, 0x0, 0b1, 0x0, 0b1')
-        s = pack('2*(uint:12, 3*(7, 6))', *range(3, 17))
+        s = pack('2*(uint:12, 3*(7, 6))', *list(range(3, 17)))
         a = s.unpack('12, 7, 6, 7, 6, 7, 6, 12, 7, 6, 7, 6, 7, 6')
         self.assertEqual(a, list(range(3, 17)))
         b = s.unpack('2*(12,3*(7,6))')
